unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Borland.Vcl.ComCtrls, KA.DbAware.DBTreeView, Borland.Vcl.Db,
  KA.Data.KADao.Table, System.ComponentModel, KA.Data.KADao.DataBase,
  Borland.Vcl.Grids, Borland.Vcl.DBGrids, Borland.Vcl.StdCtrls,
  Borland.Vcl.Mask, Borland.Vcl.DBCtrls, Borland.Vcl.ExtCtrls,
  Borland.Vcl.ImgList,CommCtrl;

type
  TForm1 = class(TForm)
    KADaoDatabase1: TKADaoDatabase;
    KADaoTable1: TKADaoTable;
    DataSource1: TDataSource;
    KADBTreeView1: TKADBTreeView;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    DBGrid1: TDBGrid;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Button10: TButton;
    DBEdit1: TDBEdit;
    DBNavigator1: TDBNavigator;
    ImageList1: TImageList;
    CheckBox3: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure KADBTreeView1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure KADaoTable1AfterDelete(DataSet: TDataSet);
    procedure KADBTreeView1GetImageIndex(Sender: TObject; Node: TTreeNode);
    procedure CheckBox3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.nfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  KADBTreeView1.Items.Item[0].Expand(True);
end;

procedure TForm1.KADBTreeView1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
 Accept := False;
 if (Sender=Source) And (Sender Is TKADBTreeView) Then Accept := True;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  KADBTreeView1.RebuildTree;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  KADBTreeView1.RebuildDataset;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if Assigned(KADBTreeView1.Selected) Then
     KADBTreeView1.PositionUp(KADBTreeView1.Selected);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if Assigned(KADBTreeView1.Selected) Then
     KADBTreeView1.PositionDown(KADBTreeView1.Selected);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if Assigned(KADBTreeView1.Selected) Then
     KADBTreeView1.LevelUp(KADBTreeView1.Selected);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if Assigned(KADBTreeView1.Selected) Then
     KADBTreeView1.LevelDown(KADBTreeView1.Selected);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  if Assigned(KADBTreeView1.Selected) Then
      KADBTreeView1.AddEmptyNode(KADBTreeView1.Selected);
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
 if Assigned(KADBTreeView1.Selected) Then
     KADBTreeView1.DeleteNode(KADBTreeView1.Selected);
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  if KaDaoTable1.Find_Next('ID',16,[]) Then ShowMessage('Found at pos: '+IntTostr(KaDaoTable1.RecNo));
end;

procedure TForm1.Button10Click(Sender: TObject);
Var
  X : Integer;
begin
  For X := 0 To KADBTreeView1.Items.Count-1 do
      Begin
        if KADBTreeView1.Items.Item[X].Level=1 Then
           Begin
             if KADBTreeView1.HasCheckbox(KADBTreeView1.Items.Item[X]) Then
                KADBTreeView1.HideCheckbox(KADBTreeView1.Items.Item[X])
             Else
                KADBTreeView1.ShowCheckbox(KADBTreeView1.Items.Item[X]);
           End;
      End;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  KADBTreeView1.Db_ShowRootParent := CheckBox1.Checked;
  KADBTreeView1.Items.Item[0].Expand(True);
end;


procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  KADBTreeView1.Checkboxes := CheckBox2.Checked;
  KADBTreeView1.Items[0].Expand(True);
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  if CheckBox3.Checked Then
     Begin
      KADBTreeView1.Db_HandleDragDrop := True;
      KADBTreeView1.DragMode          := dmAutomatic;
     End
  Else
     Begin
       KADBTreeView1.Db_HandleDragDrop := True;
       KADBTreeView1.DragMode          := dmManual;
     End;
end;



procedure TForm1.KADaoTable1AfterDelete(DataSet: TDataSet);
begin
  KADBTreeView1.RecordDeleted('');
end;

procedure TForm1.KADBTreeView1GetImageIndex(Sender: TObject;
  Node: TTreeNode);
begin
 If Node.Parent=Nil Then
    Begin
      Node.ImageIndex    := 3;
      Node.SelectedIndex := 3;
    End
 Else
 If Node.HasChildren Then
    Begin
      if Node.Expanded Then
         Begin
           Node.ImageIndex    := 2;
           Node.SelectedIndex := 2;
         End
      Else
         Begin
           Node.ImageIndex    := 1;
           Node.SelectedIndex := 1;
         End;
    End
 Else
    Begin
      Node.ImageIndex    := 0;
      Node.SelectedIndex := 0;
    End;
end;


end.
